/* Settings.c generated by valac 0.38.10, the Vala compiler
 * generated from Settings.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
* Copyright (c) 2012–2018 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Corentin Noël <corentin@elementary.io>
*/

#include <glib.h>
#include <glib-object.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>


#define APP_CENTER_TYPE_SETTINGS (app_center_settings_get_type ())
#define APP_CENTER_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_TYPE_SETTINGS, AppCenterSettings))
#define APP_CENTER_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_TYPE_SETTINGS, AppCenterSettingsClass))
#define APP_CENTER_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_TYPE_SETTINGS))
#define APP_CENTER_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_TYPE_SETTINGS))
#define APP_CENTER_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_TYPE_SETTINGS, AppCenterSettingsClass))

typedef struct _AppCenterSettings AppCenterSettings;
typedef struct _AppCenterSettingsClass AppCenterSettingsClass;
typedef struct _AppCenterSettingsPrivate AppCenterSettingsPrivate;

#define APP_CENTER_SETTINGS_TYPE_WINDOW_STATE (app_center_settings_window_state_get_type ())
enum  {
	APP_CENTER_SETTINGS_0_PROPERTY,
	APP_CENTER_SETTINGS_WINDOW_WIDTH_PROPERTY,
	APP_CENTER_SETTINGS_WINDOW_HEIGHT_PROPERTY,
	APP_CENTER_SETTINGS_WINDOW_STATE_PROPERTY,
	APP_CENTER_SETTINGS_WINDOW_X_PROPERTY,
	APP_CENTER_SETTINGS_WINDOW_Y_PROPERTY,
	APP_CENTER_SETTINGS_DEVELOPER_MODE_PROPERTY,
	APP_CENTER_SETTINGS_RESET_PAID_APPS_PROPERTY,
	APP_CENTER_SETTINGS_PAID_APPS_PROPERTY,
	APP_CENTER_SETTINGS_CONTENT_WARNING_PROPERTY,
	APP_CENTER_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* app_center_settings_properties[APP_CENTER_SETTINGS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _AppCenterSettings {
	GraniteServicesSettings parent_instance;
	AppCenterSettingsPrivate * priv;
};

struct _AppCenterSettingsClass {
	GraniteServicesSettingsClass parent_class;
};

typedef enum  {
	APP_CENTER_SETTINGS_WINDOW_STATE_NORMAL,
	APP_CENTER_SETTINGS_WINDOW_STATE_MAXIMIZED,
	APP_CENTER_SETTINGS_WINDOW_STATE_FULLSCREEN
} AppCenterSettingsWindowState;

struct _AppCenterSettingsPrivate {
	gint _window_width;
	gint _window_height;
	AppCenterSettingsWindowState _window_state;
	gint _window_x;
	gint _window_y;
	gboolean _developer_mode;
	gboolean _reset_paid_apps;
	gchar** _paid_apps;
	gint _paid_apps_length1;
	gint __paid_apps_size_;
	gboolean _content_warning;
};


static gpointer app_center_settings_parent_class = NULL;
static AppCenterSettings* app_center_settings_main_settings;
static AppCenterSettings* app_center_settings_main_settings = NULL;

GType app_center_settings_get_type (void) G_GNUC_CONST;
GType app_center_settings_window_state_get_type (void) G_GNUC_CONST;
#define APP_CENTER_SETTINGS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), APP_CENTER_TYPE_SETTINGS, AppCenterSettingsPrivate))
AppCenterSettings* app_center_settings_get_default (void);
static AppCenterSettings* app_center_settings_new (void);
static AppCenterSettings* app_center_settings_construct (GType object_type);
void app_center_settings_add_paid_app (AppCenterSettings* self, const gchar* id);
gchar** app_center_settings_get_paid_apps (AppCenterSettings* self, int* result_length1);
static gboolean _vala_string_array_contains (gchar* * stack, int stack_length, gchar* needle);
static gchar** _vala_array_dup1 (gchar** self, int length);
static void _vala_array_add1 (gchar** * array, int* length, int* size, gchar* value);
void app_center_settings_set_paid_apps (AppCenterSettings* self, gchar** value, int value_length1);
gint app_center_settings_get_window_width (AppCenterSettings* self);
void app_center_settings_set_window_width (AppCenterSettings* self, gint value);
gint app_center_settings_get_window_height (AppCenterSettings* self);
void app_center_settings_set_window_height (AppCenterSettings* self, gint value);
AppCenterSettingsWindowState app_center_settings_get_window_state (AppCenterSettings* self);
void app_center_settings_set_window_state (AppCenterSettings* self, AppCenterSettingsWindowState value);
gint app_center_settings_get_window_x (AppCenterSettings* self);
void app_center_settings_set_window_x (AppCenterSettings* self, gint value);
gint app_center_settings_get_window_y (AppCenterSettings* self);
void app_center_settings_set_window_y (AppCenterSettings* self, gint value);
gboolean app_center_settings_get_developer_mode (AppCenterSettings* self);
void app_center_settings_set_developer_mode (AppCenterSettings* self, gboolean value);
gboolean app_center_settings_get_reset_paid_apps (AppCenterSettings* self);
void app_center_settings_set_reset_paid_apps (AppCenterSettings* self, gboolean value);
static gchar** _vala_array_dup2 (gchar** self, int length);
gboolean app_center_settings_get_content_warning (AppCenterSettings* self);
void app_center_settings_set_content_warning (AppCenterSettings* self, gboolean value);
static void app_center_settings_finalize (GObject * obj);
static void _vala_app_center_settings_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_app_center_settings_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


GType app_center_settings_window_state_get_type (void) {
	static volatile gsize app_center_settings_window_state_type_id__volatile = 0;
	if (g_once_init_enter (&app_center_settings_window_state_type_id__volatile)) {
		static const GEnumValue values[] = {{APP_CENTER_SETTINGS_WINDOW_STATE_NORMAL, "APP_CENTER_SETTINGS_WINDOW_STATE_NORMAL", "normal"}, {APP_CENTER_SETTINGS_WINDOW_STATE_MAXIMIZED, "APP_CENTER_SETTINGS_WINDOW_STATE_MAXIMIZED", "maximized"}, {APP_CENTER_SETTINGS_WINDOW_STATE_FULLSCREEN, "APP_CENTER_SETTINGS_WINDOW_STATE_FULLSCREEN", "fullscreen"}, {0, NULL, NULL}};
		GType app_center_settings_window_state_type_id;
		app_center_settings_window_state_type_id = g_enum_register_static ("AppCenterSettingsWindowState", values);
		g_once_init_leave (&app_center_settings_window_state_type_id__volatile, app_center_settings_window_state_type_id);
	}
	return app_center_settings_window_state_type_id__volatile;
}


AppCenterSettings* app_center_settings_get_default (void) {
	AppCenterSettings* result = NULL;
	AppCenterSettings* _tmp0_;
	AppCenterSettings* _tmp2_;
	_tmp0_ = app_center_settings_main_settings;
	if (_tmp0_ == NULL) {
		AppCenterSettings* _tmp1_;
		_tmp1_ = app_center_settings_new ();
		_g_object_unref0 (app_center_settings_main_settings);
		app_center_settings_main_settings = _tmp1_;
	}
	_tmp2_ = app_center_settings_main_settings;
	result = _tmp2_;
	return result;
}


static gboolean _vala_string_array_contains (gchar* * stack, int stack_length, gchar* needle) {
	int i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}


static gchar** _vala_array_dup1 (gchar** self, int length) {
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


static void _vala_array_add1 (gchar** * array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


void app_center_settings_add_paid_app (AppCenterSettings* self, const gchar* id) {
	const gchar* _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gchar** _tmp2_;
	gint _tmp2__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (id != NULL);
	_tmp0_ = id;
	_tmp1_ = app_center_settings_get_paid_apps (self, &_tmp1__length1);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _tmp1__length1;
	if (!_vala_string_array_contains (_tmp2_, _tmp2__length1, _tmp0_)) {
		gchar** apps_copy = NULL;
		gchar** _tmp3_;
		gint _tmp3__length1;
		gchar** _tmp4_;
		gint _tmp4__length1;
		gchar** _tmp5_;
		gint _tmp5__length1;
		gint apps_copy_length1;
		gint _apps_copy_size_;
		gchar** _tmp6_;
		gint _tmp6__length1;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar** _tmp9_;
		gint _tmp9__length1;
		_tmp3_ = app_center_settings_get_paid_apps (self, &_tmp3__length1);
		_tmp4_ = _tmp3_;
		_tmp4__length1 = _tmp3__length1;
		_tmp5_ = (_tmp4_ != NULL) ? _vala_array_dup1 (_tmp4_, _tmp4__length1) : ((gpointer) _tmp4_);
		_tmp5__length1 = _tmp4__length1;
		apps_copy = _tmp5_;
		apps_copy_length1 = _tmp5__length1;
		_apps_copy_size_ = apps_copy_length1;
		_tmp6_ = apps_copy;
		_tmp6__length1 = apps_copy_length1;
		_tmp7_ = id;
		_tmp8_ = g_strdup (_tmp7_);
		_vala_array_add1 (&apps_copy, &apps_copy_length1, &_apps_copy_size_, _tmp8_);
		_tmp9_ = apps_copy;
		_tmp9__length1 = apps_copy_length1;
		app_center_settings_set_paid_apps (self, _tmp9_, _tmp9__length1);
		apps_copy = (_vala_array_free (apps_copy, apps_copy_length1, (GDestroyNotify) g_free), NULL);
	}
}


static AppCenterSettings* app_center_settings_construct (GType object_type) {
	AppCenterSettings * self = NULL;
	self = (AppCenterSettings*) granite_services_settings_construct (object_type, "io.elementary.appcenter.settings");
	return self;
}


static AppCenterSettings* app_center_settings_new (void) {
	return app_center_settings_construct (APP_CENTER_TYPE_SETTINGS);
}


gint app_center_settings_get_window_width (AppCenterSettings* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_window_width;
	result = _tmp0_;
	return result;
}


void app_center_settings_set_window_width (AppCenterSettings* self, gint value) {
	g_return_if_fail (self != NULL);
	if (app_center_settings_get_window_width (self) != value) {
		gint _tmp0_;
		_tmp0_ = value;
		self->priv->_window_width = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, app_center_settings_properties[APP_CENTER_SETTINGS_WINDOW_WIDTH_PROPERTY]);
	}
}


gint app_center_settings_get_window_height (AppCenterSettings* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_window_height;
	result = _tmp0_;
	return result;
}


void app_center_settings_set_window_height (AppCenterSettings* self, gint value) {
	g_return_if_fail (self != NULL);
	if (app_center_settings_get_window_height (self) != value) {
		gint _tmp0_;
		_tmp0_ = value;
		self->priv->_window_height = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, app_center_settings_properties[APP_CENTER_SETTINGS_WINDOW_HEIGHT_PROPERTY]);
	}
}


AppCenterSettingsWindowState app_center_settings_get_window_state (AppCenterSettings* self) {
	AppCenterSettingsWindowState result;
	AppCenterSettingsWindowState _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_window_state;
	result = _tmp0_;
	return result;
}


void app_center_settings_set_window_state (AppCenterSettings* self, AppCenterSettingsWindowState value) {
	g_return_if_fail (self != NULL);
	if (app_center_settings_get_window_state (self) != value) {
		AppCenterSettingsWindowState _tmp0_;
		_tmp0_ = value;
		self->priv->_window_state = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, app_center_settings_properties[APP_CENTER_SETTINGS_WINDOW_STATE_PROPERTY]);
	}
}


gint app_center_settings_get_window_x (AppCenterSettings* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_window_x;
	result = _tmp0_;
	return result;
}


void app_center_settings_set_window_x (AppCenterSettings* self, gint value) {
	g_return_if_fail (self != NULL);
	if (app_center_settings_get_window_x (self) != value) {
		gint _tmp0_;
		_tmp0_ = value;
		self->priv->_window_x = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, app_center_settings_properties[APP_CENTER_SETTINGS_WINDOW_X_PROPERTY]);
	}
}


gint app_center_settings_get_window_y (AppCenterSettings* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_window_y;
	result = _tmp0_;
	return result;
}


void app_center_settings_set_window_y (AppCenterSettings* self, gint value) {
	g_return_if_fail (self != NULL);
	if (app_center_settings_get_window_y (self) != value) {
		gint _tmp0_;
		_tmp0_ = value;
		self->priv->_window_y = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, app_center_settings_properties[APP_CENTER_SETTINGS_WINDOW_Y_PROPERTY]);
	}
}


gboolean app_center_settings_get_developer_mode (AppCenterSettings* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_developer_mode;
	result = _tmp0_;
	return result;
}


void app_center_settings_set_developer_mode (AppCenterSettings* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (app_center_settings_get_developer_mode (self) != value) {
		gboolean _tmp0_;
		_tmp0_ = value;
		self->priv->_developer_mode = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, app_center_settings_properties[APP_CENTER_SETTINGS_DEVELOPER_MODE_PROPERTY]);
	}
}


gboolean app_center_settings_get_reset_paid_apps (AppCenterSettings* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_reset_paid_apps;
	result = _tmp0_;
	return result;
}


void app_center_settings_set_reset_paid_apps (AppCenterSettings* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (app_center_settings_get_reset_paid_apps (self) != value) {
		gboolean _tmp0_;
		_tmp0_ = value;
		self->priv->_reset_paid_apps = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, app_center_settings_properties[APP_CENTER_SETTINGS_RESET_PAID_APPS_PROPERTY]);
	}
}


gchar** app_center_settings_get_paid_apps (AppCenterSettings* self, int* result_length1) {
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_paid_apps;
	_tmp0__length1 = self->priv->_paid_apps_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}


static gchar** _vala_array_dup2 (gchar** self, int length) {
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


void app_center_settings_set_paid_apps (AppCenterSettings* self, gchar** value, int value_length1) {
	int old_value_length;
	g_return_if_fail (self != NULL);
	if (app_center_settings_get_paid_apps (self, &old_value_length) != value) {
		gchar** _tmp0_;
		gint _tmp0__length1;
		gchar** _tmp1_;
		gint _tmp1__length1;
		_tmp0_ = value;
		_tmp0__length1 = value_length1;
		_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup2 (_tmp0_, _tmp0__length1) : ((gpointer) _tmp0_);
		_tmp1__length1 = _tmp0__length1;
		self->priv->_paid_apps = (_vala_array_free (self->priv->_paid_apps, self->priv->_paid_apps_length1, (GDestroyNotify) g_free), NULL);
		self->priv->_paid_apps = _tmp1_;
		self->priv->_paid_apps_length1 = _tmp1__length1;
		self->priv->__paid_apps_size_ = self->priv->_paid_apps_length1;
		g_object_notify_by_pspec ((GObject *) self, app_center_settings_properties[APP_CENTER_SETTINGS_PAID_APPS_PROPERTY]);
	}
}


gboolean app_center_settings_get_content_warning (AppCenterSettings* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_content_warning;
	result = _tmp0_;
	return result;
}


void app_center_settings_set_content_warning (AppCenterSettings* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (app_center_settings_get_content_warning (self) != value) {
		gboolean _tmp0_;
		_tmp0_ = value;
		self->priv->_content_warning = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, app_center_settings_properties[APP_CENTER_SETTINGS_CONTENT_WARNING_PROPERTY]);
	}
}


static void app_center_settings_class_init (AppCenterSettingsClass * klass) {
	app_center_settings_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (AppCenterSettingsPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_app_center_settings_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_app_center_settings_set_property;
	G_OBJECT_CLASS (klass)->finalize = app_center_settings_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_SETTINGS_WINDOW_WIDTH_PROPERTY, app_center_settings_properties[APP_CENTER_SETTINGS_WINDOW_WIDTH_PROPERTY] = g_param_spec_int ("window-width", "window-width", "window-width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_SETTINGS_WINDOW_HEIGHT_PROPERTY, app_center_settings_properties[APP_CENTER_SETTINGS_WINDOW_HEIGHT_PROPERTY] = g_param_spec_int ("window-height", "window-height", "window-height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_SETTINGS_WINDOW_STATE_PROPERTY, app_center_settings_properties[APP_CENTER_SETTINGS_WINDOW_STATE_PROPERTY] = g_param_spec_enum ("window-state", "window-state", "window-state", APP_CENTER_SETTINGS_TYPE_WINDOW_STATE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_SETTINGS_WINDOW_X_PROPERTY, app_center_settings_properties[APP_CENTER_SETTINGS_WINDOW_X_PROPERTY] = g_param_spec_int ("window-x", "window-x", "window-x", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_SETTINGS_WINDOW_Y_PROPERTY, app_center_settings_properties[APP_CENTER_SETTINGS_WINDOW_Y_PROPERTY] = g_param_spec_int ("window-y", "window-y", "window-y", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_SETTINGS_DEVELOPER_MODE_PROPERTY, app_center_settings_properties[APP_CENTER_SETTINGS_DEVELOPER_MODE_PROPERTY] = g_param_spec_boolean ("developer-mode", "developer-mode", "developer-mode", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_SETTINGS_RESET_PAID_APPS_PROPERTY, app_center_settings_properties[APP_CENTER_SETTINGS_RESET_PAID_APPS_PROPERTY] = g_param_spec_boolean ("reset-paid-apps", "reset-paid-apps", "reset-paid-apps", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_SETTINGS_PAID_APPS_PROPERTY, app_center_settings_properties[APP_CENTER_SETTINGS_PAID_APPS_PROPERTY] = g_param_spec_boxed ("paid-apps", "paid-apps", "paid-apps", G_TYPE_STRV, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_SETTINGS_CONTENT_WARNING_PROPERTY, app_center_settings_properties[APP_CENTER_SETTINGS_CONTENT_WARNING_PROPERTY] = g_param_spec_boolean ("content-warning", "content-warning", "content-warning", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void app_center_settings_instance_init (AppCenterSettings * self) {
	self->priv = APP_CENTER_SETTINGS_GET_PRIVATE (self);
}


static void app_center_settings_finalize (GObject * obj) {
	AppCenterSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APP_CENTER_TYPE_SETTINGS, AppCenterSettings);
	self->priv->_paid_apps = (_vala_array_free (self->priv->_paid_apps, self->priv->_paid_apps_length1, (GDestroyNotify) g_free), NULL);
	G_OBJECT_CLASS (app_center_settings_parent_class)->finalize (obj);
}


GType app_center_settings_get_type (void) {
	static volatile gsize app_center_settings_type_id__volatile = 0;
	if (g_once_init_enter (&app_center_settings_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AppCenterSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_center_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppCenterSettings), 0, (GInstanceInitFunc) app_center_settings_instance_init, NULL };
		GType app_center_settings_type_id;
		app_center_settings_type_id = g_type_register_static (GRANITE_SERVICES_TYPE_SETTINGS, "AppCenterSettings", &g_define_type_info, 0);
		g_once_init_leave (&app_center_settings_type_id__volatile, app_center_settings_type_id);
	}
	return app_center_settings_type_id__volatile;
}


static void _vala_app_center_settings_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	AppCenterSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APP_CENTER_TYPE_SETTINGS, AppCenterSettings);
	switch (property_id) {
		case APP_CENTER_SETTINGS_WINDOW_WIDTH_PROPERTY:
		g_value_set_int (value, app_center_settings_get_window_width (self));
		break;
		case APP_CENTER_SETTINGS_WINDOW_HEIGHT_PROPERTY:
		g_value_set_int (value, app_center_settings_get_window_height (self));
		break;
		case APP_CENTER_SETTINGS_WINDOW_STATE_PROPERTY:
		g_value_set_enum (value, app_center_settings_get_window_state (self));
		break;
		case APP_CENTER_SETTINGS_WINDOW_X_PROPERTY:
		g_value_set_int (value, app_center_settings_get_window_x (self));
		break;
		case APP_CENTER_SETTINGS_WINDOW_Y_PROPERTY:
		g_value_set_int (value, app_center_settings_get_window_y (self));
		break;
		case APP_CENTER_SETTINGS_DEVELOPER_MODE_PROPERTY:
		g_value_set_boolean (value, app_center_settings_get_developer_mode (self));
		break;
		case APP_CENTER_SETTINGS_RESET_PAID_APPS_PROPERTY:
		g_value_set_boolean (value, app_center_settings_get_reset_paid_apps (self));
		break;
		case APP_CENTER_SETTINGS_PAID_APPS_PROPERTY:
		{
			int length;
			g_value_set_boxed (value, app_center_settings_get_paid_apps (self, &length));
		}
		break;
		case APP_CENTER_SETTINGS_CONTENT_WARNING_PROPERTY:
		g_value_set_boolean (value, app_center_settings_get_content_warning (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_app_center_settings_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	AppCenterSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APP_CENTER_TYPE_SETTINGS, AppCenterSettings);
	switch (property_id) {
		case APP_CENTER_SETTINGS_WINDOW_WIDTH_PROPERTY:
		app_center_settings_set_window_width (self, g_value_get_int (value));
		break;
		case APP_CENTER_SETTINGS_WINDOW_HEIGHT_PROPERTY:
		app_center_settings_set_window_height (self, g_value_get_int (value));
		break;
		case APP_CENTER_SETTINGS_WINDOW_STATE_PROPERTY:
		app_center_settings_set_window_state (self, g_value_get_enum (value));
		break;
		case APP_CENTER_SETTINGS_WINDOW_X_PROPERTY:
		app_center_settings_set_window_x (self, g_value_get_int (value));
		break;
		case APP_CENTER_SETTINGS_WINDOW_Y_PROPERTY:
		app_center_settings_set_window_y (self, g_value_get_int (value));
		break;
		case APP_CENTER_SETTINGS_DEVELOPER_MODE_PROPERTY:
		app_center_settings_set_developer_mode (self, g_value_get_boolean (value));
		break;
		case APP_CENTER_SETTINGS_RESET_PAID_APPS_PROPERTY:
		app_center_settings_set_reset_paid_apps (self, g_value_get_boolean (value));
		break;
		case APP_CENTER_SETTINGS_PAID_APPS_PROPERTY:
		{
			gpointer boxed;
			boxed = g_value_get_boxed (value);
			app_center_settings_set_paid_apps (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
		}
		break;
		case APP_CENTER_SETTINGS_CONTENT_WARNING_PROPERTY:
		app_center_settings_set_content_warning (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



