/* SuspendControl.c generated by valac 0.38.10, the Vala compiler
 * generated from SuspendControl.vala, do not modify */

/*
* Copyright (c) 2011-2018 elementary LLC (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Richard Fairthorne <richard.fairthorne@gmail.com>
*/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define TYPE_SESSION_MANAGER (session_manager_get_type ())
#define SESSION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SESSION_MANAGER, SessionManager))
#define IS_SESSION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SESSION_MANAGER))
#define SESSION_MANAGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_SESSION_MANAGER, SessionManagerIface))

typedef struct _SessionManager SessionManager;
typedef struct _SessionManagerIface SessionManagerIface;

#define TYPE_SESSION_MANAGER_PROXY (session_manager_proxy_get_type ())
typedef GDBusProxy SessionManagerProxy;
typedef GDBusProxyClass SessionManagerProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SUSPEND_CONTROL (suspend_control_get_type ())
#define SUSPEND_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUSPEND_CONTROL, SuspendControl))
#define SUSPEND_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUSPEND_CONTROL, SuspendControlClass))
#define IS_SUSPEND_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUSPEND_CONTROL))
#define IS_SUSPEND_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUSPEND_CONTROL))
#define SUSPEND_CONTROL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUSPEND_CONTROL, SuspendControlClass))

typedef struct _SuspendControl SuspendControl;
typedef struct _SuspendControlClass SuspendControlClass;
typedef struct _SuspendControlPrivate SuspendControlPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _suspend_control_unref0(var) ((var == NULL) ? NULL : (var = (suspend_control_unref (var), NULL)))
typedef struct _ParamSpecSuspendControl ParamSpecSuspendControl;

struct _SessionManagerIface {
	GTypeInterface parent_iface;
	guint32 (*inhibit) (SessionManager* self, const gchar* app_id, guint32 toplevel_xid, const gchar* reason, guint32 flags, GError** error);
	void (*uninhibit) (SessionManager* self, guint32 inhibit_cookie, GError** error);
	void (*reboot) (SessionManager* self, GError** error);
};

struct _SuspendControl {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SuspendControlPrivate * priv;
};

struct _SuspendControlClass {
	GTypeClass parent_class;
	void (*finalize) (SuspendControl *self);
};

struct _SuspendControlPrivate {
	SessionManager* sm;
	gboolean inhibited;
	guint32 inhibit_cookie;
	gboolean supported;
};

struct _ParamSpecSuspendControl {
	GParamSpec parent_instance;
};


static gpointer suspend_control_parent_class = NULL;
static SuspendControl* suspend_control_sc;
static SuspendControl* suspend_control_sc = NULL;

GType session_manager_proxy_get_type (void) G_GNUC_CONST;
guint session_manager_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType session_manager_get_type (void) G_GNUC_CONST;
guint32 session_manager_inhibit (SessionManager* self, const gchar* app_id, guint32 toplevel_xid, const gchar* reason, guint32 flags, GError** error);
void session_manager_uninhibit (SessionManager* self, guint32 inhibit_cookie, GError** error);
void session_manager_reboot (SessionManager* self, GError** error);
static void session_manager_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static guint32 session_manager_proxy_inhibit (SessionManager* self, const gchar* app_id, guint32 toplevel_xid, const gchar* reason, guint32 flags, GError** error);
static void session_manager_proxy_uninhibit (SessionManager* self, guint32 inhibit_cookie, GError** error);
static void session_manager_proxy_reboot (SessionManager* self, GError** error);
static void session_manager_proxy_session_manager_interface_init (SessionManagerIface* iface);
static void _dbus_session_manager_inhibit (SessionManager* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_session_manager_uninhibit (SessionManager* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_session_manager_reboot (SessionManager* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void session_manager_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* session_manager_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean session_manager_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _session_manager_unregister_object (gpointer user_data);
gpointer suspend_control_ref (gpointer instance);
void suspend_control_unref (gpointer instance);
GParamSpec* param_spec_suspend_control (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_suspend_control (GValue* value, gpointer v_object);
void value_take_suspend_control (GValue* value, gpointer v_object);
gpointer value_get_suspend_control (const GValue* value);
GType suspend_control_get_type (void) G_GNUC_CONST;
#define SUSPEND_CONTROL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SUSPEND_CONTROL, SuspendControlPrivate))
SuspendControl* suspend_control_new (void);
SuspendControl* suspend_control_construct (GType object_type);
SuspendControl* suspend_control_get_default (void);
gboolean suspend_control_inhibit (SuspendControl* self);
gboolean suspend_control_uninhibit (SuspendControl* self);
void suspend_control_reboot (SuspendControl* self, GError** error);
static void suspend_control_finalize (SuspendControl * obj);

static const GDBusArgInfo _session_manager_dbus_arg_info_inhibit_app_id = {-1, "app_id", "s"};
static const GDBusArgInfo _session_manager_dbus_arg_info_inhibit_toplevel_xid = {-1, "toplevel_xid", "u"};
static const GDBusArgInfo _session_manager_dbus_arg_info_inhibit_reason = {-1, "reason", "s"};
static const GDBusArgInfo _session_manager_dbus_arg_info_inhibit_flags = {-1, "flags", "u"};
static const GDBusArgInfo _session_manager_dbus_arg_info_inhibit_result = {-1, "result", "u"};
static const GDBusArgInfo * const _session_manager_dbus_arg_info_inhibit_in[] = {&_session_manager_dbus_arg_info_inhibit_app_id, &_session_manager_dbus_arg_info_inhibit_toplevel_xid, &_session_manager_dbus_arg_info_inhibit_reason, &_session_manager_dbus_arg_info_inhibit_flags, NULL};
static const GDBusArgInfo * const _session_manager_dbus_arg_info_inhibit_out[] = {&_session_manager_dbus_arg_info_inhibit_result, NULL};
static const GDBusMethodInfo _session_manager_dbus_method_info_inhibit = {-1, "Inhibit", (GDBusArgInfo **) (&_session_manager_dbus_arg_info_inhibit_in), (GDBusArgInfo **) (&_session_manager_dbus_arg_info_inhibit_out)};
static const GDBusArgInfo _session_manager_dbus_arg_info_uninhibit_inhibit_cookie = {-1, "inhibit_cookie", "u"};
static const GDBusArgInfo * const _session_manager_dbus_arg_info_uninhibit_in[] = {&_session_manager_dbus_arg_info_uninhibit_inhibit_cookie, NULL};
static const GDBusArgInfo * const _session_manager_dbus_arg_info_uninhibit_out[] = {NULL};
static const GDBusMethodInfo _session_manager_dbus_method_info_uninhibit = {-1, "Uninhibit", (GDBusArgInfo **) (&_session_manager_dbus_arg_info_uninhibit_in), (GDBusArgInfo **) (&_session_manager_dbus_arg_info_uninhibit_out)};
static const GDBusArgInfo * const _session_manager_dbus_arg_info_reboot_in[] = {NULL};
static const GDBusArgInfo * const _session_manager_dbus_arg_info_reboot_out[] = {NULL};
static const GDBusMethodInfo _session_manager_dbus_method_info_reboot = {-1, "Reboot", (GDBusArgInfo **) (&_session_manager_dbus_arg_info_reboot_in), (GDBusArgInfo **) (&_session_manager_dbus_arg_info_reboot_out)};
static const GDBusMethodInfo * const _session_manager_dbus_method_info[] = {&_session_manager_dbus_method_info_inhibit, &_session_manager_dbus_method_info_uninhibit, &_session_manager_dbus_method_info_reboot, NULL};
static const GDBusSignalInfo * const _session_manager_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _session_manager_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _session_manager_dbus_interface_info = {-1, "org.gnome.SessionManager", (GDBusMethodInfo **) (&_session_manager_dbus_method_info), (GDBusSignalInfo **) (&_session_manager_dbus_signal_info), (GDBusPropertyInfo **) (&_session_manager_dbus_property_info)};
static const GDBusInterfaceVTable _session_manager_dbus_interface_vtable = {session_manager_dbus_interface_method_call, session_manager_dbus_interface_get_property, session_manager_dbus_interface_set_property};

guint32 session_manager_inhibit (SessionManager* self, const gchar* app_id, guint32 toplevel_xid, const gchar* reason, guint32 flags, GError** error) {
	g_return_val_if_fail (self != NULL, 0U);
	return SESSION_MANAGER_GET_INTERFACE (self)->inhibit (self, app_id, toplevel_xid, reason, flags, error);
}


void session_manager_uninhibit (SessionManager* self, guint32 inhibit_cookie, GError** error) {
	g_return_if_fail (self != NULL);
	SESSION_MANAGER_GET_INTERFACE (self)->uninhibit (self, inhibit_cookie, error);
}


void session_manager_reboot (SessionManager* self, GError** error) {
	g_return_if_fail (self != NULL);
	SESSION_MANAGER_GET_INTERFACE (self)->reboot (self, error);
}


static void session_manager_base_init (SessionManagerIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType session_manager_get_type (void) {
	static volatile gsize session_manager_type_id__volatile = 0;
	if (g_once_init_enter (&session_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SessionManagerIface), (GBaseInitFunc) session_manager_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType session_manager_type_id;
		session_manager_type_id = g_type_register_static (G_TYPE_INTERFACE, "SessionManager", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (session_manager_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (session_manager_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) session_manager_proxy_get_type);
		g_type_set_qdata (session_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.SessionManager");
		g_type_set_qdata (session_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_session_manager_dbus_interface_info));
		g_type_set_qdata (session_manager_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) session_manager_register_object);
		g_once_init_leave (&session_manager_type_id__volatile, session_manager_type_id);
	}
	return session_manager_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (SessionManagerProxy, session_manager_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_SESSION_MANAGER, session_manager_proxy_session_manager_interface_init) )
static void session_manager_proxy_class_init (SessionManagerProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = session_manager_proxy_g_signal;
}


static void session_manager_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
}


static void session_manager_proxy_init (SessionManagerProxy* self) {
}


static guint32 session_manager_proxy_inhibit (SessionManager* self, const gchar* app_id, guint32 toplevel_xid, const gchar* reason, guint32 flags, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint32 _result = 0U;
	GVariant* _tmp2_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.SessionManager", "Inhibit");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (app_id));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (toplevel_xid));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (reason));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (flags));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		guint32 _tmp0_ = 0U;
		return _tmp0_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		guint32 _tmp1_ = 0U;
		g_object_unref (_reply_message);
		return _tmp1_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp2_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_uint32 (_tmp2_);
	g_variant_unref (_tmp2_);
	g_object_unref (_reply_message);
	return _result;
}


static void session_manager_proxy_uninhibit (SessionManager* self, guint32 inhibit_cookie, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.SessionManager", "Uninhibit");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (inhibit_cookie));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void session_manager_proxy_reboot (SessionManager* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.SessionManager", "Reboot");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void session_manager_proxy_session_manager_interface_init (SessionManagerIface* iface) {
	iface->inhibit = session_manager_proxy_inhibit;
	iface->uninhibit = session_manager_proxy_uninhibit;
	iface->reboot = session_manager_proxy_reboot;
}


static void _dbus_session_manager_inhibit (SessionManager* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* app_id = NULL;
	GVariant* _tmp3_;
	guint32 toplevel_xid = 0U;
	GVariant* _tmp4_;
	gchar* reason = NULL;
	GVariant* _tmp5_;
	guint32 flags = 0U;
	GVariant* _tmp6_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint32 result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp3_ = g_variant_iter_next_value (&_arguments_iter);
	app_id = g_variant_dup_string (_tmp3_, NULL);
	g_variant_unref (_tmp3_);
	_tmp4_ = g_variant_iter_next_value (&_arguments_iter);
	toplevel_xid = g_variant_get_uint32 (_tmp4_);
	g_variant_unref (_tmp4_);
	_tmp5_ = g_variant_iter_next_value (&_arguments_iter);
	reason = g_variant_dup_string (_tmp5_, NULL);
	g_variant_unref (_tmp5_);
	_tmp6_ = g_variant_iter_next_value (&_arguments_iter);
	flags = g_variant_get_uint32 (_tmp6_);
	g_variant_unref (_tmp6_);
	result = session_manager_inhibit (self, app_id, toplevel_xid, reason, flags, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (app_id);
	_g_free0 (reason);
}


static void _dbus_session_manager_uninhibit (SessionManager* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 inhibit_cookie = 0U;
	GVariant* _tmp7_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp7_ = g_variant_iter_next_value (&_arguments_iter);
	inhibit_cookie = g_variant_get_uint32 (_tmp7_);
	g_variant_unref (_tmp7_);
	session_manager_uninhibit (self, inhibit_cookie, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_session_manager_reboot (SessionManager* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	session_manager_reboot (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void session_manager_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Inhibit") == 0) {
		_dbus_session_manager_inhibit (object, parameters, invocation);
	} else if (strcmp (method_name, "Uninhibit") == 0) {
		_dbus_session_manager_uninhibit (object, parameters, invocation);
	} else if (strcmp (method_name, "Reboot") == 0) {
		_dbus_session_manager_reboot (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* session_manager_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean session_manager_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


guint session_manager_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_session_manager_dbus_interface_info), &_session_manager_dbus_interface_vtable, data, _session_manager_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}


static void _session_manager_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


SuspendControl* suspend_control_construct (GType object_type) {
	SuspendControl* self = NULL;
	GError * _inner_error_ = NULL;
	self = (SuspendControl*) g_type_create_instance (object_type);
	{
		SessionManager* _tmp0_ = NULL;
		SessionManager* _tmp1_;
		SessionManager* _tmp2_;
		_tmp1_ = g_initable_new (TYPE_SESSION_MANAGER_PROXY, NULL, &_inner_error_, "g-flags", 0, "g-name", "org.gnome.SessionManager", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/gnome/SessionManager", "g-interface-name", "org.gnome.SessionManager", "g-interface-info", g_type_get_qdata (TYPE_SESSION_MANAGER, g_quark_from_static_string ("vala-dbus-interface-info")), NULL);
		_tmp0_ = (SessionManager*) _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch6_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (self->priv->sm);
		self->priv->sm = _tmp2_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error_;
		_inner_error_ = NULL;
		self->priv->supported = FALSE;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_critical ("SuspendControl.vala:43: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally6:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	return self;
}


SuspendControl* suspend_control_new (void) {
	return suspend_control_construct (TYPE_SUSPEND_CONTROL);
}


SuspendControl* suspend_control_get_default (void) {
	SuspendControl* result = NULL;
	SuspendControl* _tmp0_;
	SuspendControl* _tmp2_;
	_tmp0_ = suspend_control_sc;
	if (_tmp0_ == NULL) {
		SuspendControl* _tmp1_;
		_tmp1_ = suspend_control_new ();
		_suspend_control_unref0 (suspend_control_sc);
		suspend_control_sc = _tmp1_;
	}
	_tmp2_ = suspend_control_sc;
	result = _tmp2_;
	return result;
}


gboolean suspend_control_inhibit (SuspendControl* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp9_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->priv->inhibited;
	if (_tmp1_ == FALSE) {
		gboolean _tmp2_;
		_tmp2_ = self->priv->supported;
		_tmp0_ = _tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		{
			guint32 _tmp3_ = 0U;
			SessionManager* _tmp4_;
			guint32 _tmp5_;
			_tmp4_ = self->priv->sm;
			_tmp5_ = session_manager_inhibit (_tmp4_, "org.richardfairthorne.SuspendControl", (guint32) 0, "Inhibit suspend during update", (guint32) 4, &_inner_error_);
			_tmp3_ = _tmp5_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch7_g_error;
			}
			self->priv->inhibit_cookie = _tmp3_;
			self->priv->inhibited = TRUE;
		}
		goto __finally7;
		__catch7_g_error:
		{
			GError* e = NULL;
			GError* _tmp6_;
			const gchar* _tmp7_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp6_ = e;
			_tmp7_ = _tmp6_->message;
			g_critical ("SuspendControl.vala:61: %s", _tmp7_);
			_g_error_free0 (e);
		}
		__finally7:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			gboolean _tmp8_ = FALSE;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp8_;
		}
	}
	_tmp9_ = self->priv->inhibited;
	result = _tmp9_;
	return result;
}


gboolean suspend_control_uninhibit (SuspendControl* self) {
	gboolean result = FALSE;
	gboolean _tmp8_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_;
		_tmp1_ = self->priv->inhibited;
		if (_tmp1_ == TRUE) {
			gboolean _tmp2_;
			_tmp2_ = self->priv->supported;
			_tmp0_ = _tmp2_;
		} else {
			_tmp0_ = FALSE;
		}
		if (_tmp0_) {
			SessionManager* _tmp3_;
			guint32 _tmp4_;
			_tmp3_ = self->priv->sm;
			_tmp4_ = self->priv->inhibit_cookie;
			session_manager_uninhibit (_tmp3_, _tmp4_, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch8_g_error;
			}
			self->priv->inhibited = FALSE;
		}
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		g_critical ("SuspendControl.vala:75: %s", _tmp6_);
		_g_error_free0 (e);
	}
	__finally8:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gboolean _tmp7_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp7_;
	}
	_tmp8_ = self->priv->inhibited;
	result = !_tmp8_;
	return result;
}


static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


void suspend_control_reboot (SuspendControl* self, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		SessionManager* _tmp0_;
		_tmp0_ = self->priv->sm;
		session_manager_reboot (_tmp0_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch9_g_error;
		}
	}
	goto __finally9;
	__catch9_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		GError* _tmp3_;
		GError* _tmp4_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		g_critical ("SuspendControl.vala:85: failed to request a reboot from GNOME: %s\n", _tmp2_);
		_tmp3_ = e;
		_tmp4_ = _g_error_copy0 (_tmp3_);
		_inner_error_ = _tmp4_;
		_g_error_free0 (e);
		goto __finally9;
	}
	__finally9:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


static void value_suspend_control_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_suspend_control_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		suspend_control_unref (value->data[0].v_pointer);
	}
}


static void value_suspend_control_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = suspend_control_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_suspend_control_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_suspend_control_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		SuspendControl * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = suspend_control_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_suspend_control_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SuspendControl ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = suspend_control_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_suspend_control (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSuspendControl* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SUSPEND_CONTROL), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_suspend_control (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SUSPEND_CONTROL), NULL);
	return value->data[0].v_pointer;
}


void value_set_suspend_control (GValue* value, gpointer v_object) {
	SuspendControl * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SUSPEND_CONTROL));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SUSPEND_CONTROL));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		suspend_control_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		suspend_control_unref (old);
	}
}


void value_take_suspend_control (GValue* value, gpointer v_object) {
	SuspendControl * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SUSPEND_CONTROL));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SUSPEND_CONTROL));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		suspend_control_unref (old);
	}
}


static void suspend_control_class_init (SuspendControlClass * klass) {
	suspend_control_parent_class = g_type_class_peek_parent (klass);
	((SuspendControlClass *) klass)->finalize = suspend_control_finalize;
	g_type_class_add_private (klass, sizeof (SuspendControlPrivate));
}


static void suspend_control_instance_init (SuspendControl * self) {
	self->priv = SUSPEND_CONTROL_GET_PRIVATE (self);
	self->priv->inhibited = FALSE;
	self->priv->inhibit_cookie = (guint32) 0;
	self->priv->supported = TRUE;
	self->ref_count = 1;
}


static void suspend_control_finalize (SuspendControl * obj) {
	SuspendControl * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUSPEND_CONTROL, SuspendControl);
	g_signal_handlers_destroy (self);
	_g_object_unref0 (self->priv->sm);
}


GType suspend_control_get_type (void) {
	static volatile gsize suspend_control_type_id__volatile = 0;
	if (g_once_init_enter (&suspend_control_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_suspend_control_init, value_suspend_control_free_value, value_suspend_control_copy_value, value_suspend_control_peek_pointer, "p", value_suspend_control_collect_value, "p", value_suspend_control_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SuspendControlClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) suspend_control_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SuspendControl), 0, (GInstanceInitFunc) suspend_control_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType suspend_control_type_id;
		suspend_control_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SuspendControl", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&suspend_control_type_id__volatile, suspend_control_type_id);
	}
	return suspend_control_type_id__volatile;
}


gpointer suspend_control_ref (gpointer instance) {
	SuspendControl * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void suspend_control_unref (gpointer instance) {
	SuspendControl * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SUSPEND_CONTROL_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



